import { Knex } from 'knex';
import { Direction, IGridRequestDto, Operator } from './GridRequestDto';
import GridResponse from './GridResponse';
export interface ICallbackFilter {
    (queryBuilder: Knex.QueryBuilder, column: string, operator: Operator, values: string[]): Knex.QueryBuilder;
}
export interface ICallbackSorter {
    (queryBuilder: Knex.QueryBuilder, column: string, direction: Direction): Knex.QueryBuilder;
}
export default abstract class AKnexGrid<T> {
    private knex;
    constructor(knex: Knex);
    protected filterableColumns: Record<string, string | ICallbackFilter> | null;
    protected sortableColumns: Record<string, string | ICallbackSorter> | null;
    protected searchableColumns: string[] | null;
    protected abstract searchQuery(knex: Knex, dto: IGridRequestDto): any;
    protected abstract toObject(data: Record<string, unknown>): T;
    filter(dto: IGridRequestDto): Promise<GridResponse<T>>;
    protected countQuery(knex: Knex): Promise<({
        count: string | number;
    } | {
        _base: unknown;
        _hasSelection: boolean;
        _keys: string;
        _aliases: {};
        _single: boolean;
        _intersectProps: {
            count: string | number;
        };
        _unionProps: unknown;
    })[]>;
    private addPaging;
    private addSorters;
    private addFilters;
    private getFilterableColumn;
    private static addOrExpression;
}
export declare type __ΩICallbackFilter = any[];
export declare type __ΩICallbackSorter = any[];
